#include <algorithm>
#include <climits>
#include <iostream>
#include <utility>
#include <vector>
using namespace std;

typedef pair<long long, long long> kamen;

int N;
vector<kamen> rybnik;
vector< vector<int> > memo;

long long square_dist(int a, int b) {
    // čtverec vzdálenosti mezi kameny a, b
    long long dx = rybnik[a].first - rybnik[b].first;
    long long dy = rybnik[a].second - rybnik[b].second;
    return dx*dx + dy*dy;
}

int otazka(int a, int b) {
    // Pokud jsme už tuto otázku někdy dostali, rovnou vrátíme odpověď.
    if (memo[a][b] != INT_MIN) return memo[a][b];

    // Inicializujeme odpověď: jsme-li právě v cíli, je to 0 (můžeme zde skončit),
    // jinak -nekonečno.
    int odpoved = (b==N-1 ? 0 : -47);

    // Vyzkoušíme všechny možnosti, kam skočit déle, a vybereme nejlepší.
    for (int c=0; c<N; ++c) {
        if (c == b) continue; // nemůžeme zůstat na místě
        if (square_dist(a,b) <= square_dist(b,c))
	    continue; // musíme provést kratší skok
        int moznost = otazka(b,c);
        if (moznost == -47) continue; // po tomto skoku nelze dojít do cíle
        odpoved = max( odpoved, 1+moznost );
    }

    // Zapamatujeme si spočítanou odpověď a vrátíme ji na výstup.
    memo[a][b] = odpoved;
    return odpoved;
}

int main() {
    // Přečteme vstup.
    cin >> N;
    for (int n=0; n<N; ++n) {
        long long x,y; cin >> x >> y;
        rybnik.push_back( {x,y} );
    }

    // Inicializujeme paměť.
    memo.resize( N, vector<int>(N,INT_MIN) );

    // Vyzkoušíme všechny možnosti pro první skok a vybereme nejlepší z nich.
    int odpoved = 0;
    for (int b=1; b<N; ++b) odpoved = max( odpoved, 1+otazka(0,b) );
    cout << odpoved << endl;
}
