#include <algorithm>
#include <iostream>
#include <unordered_map>
#include <utility>
#include <vector>
using namespace std;

int N;
vector< pair<long long,long long> > rybnik;

void load() {
    cin >> N;
    rybnik.resize(N);
    for (int n=0; n<N; ++n) cin >> rybnik[n].first >> rybnik[n].second;
}

long long square_dist(int i, int j) {
    long long dx = rybnik[i].first - rybnik[j].first;
    long long dy = rybnik[i].second - rybnik[j].second;
    return dx*dx + dy*dy;
}

int main() {
    load();
    unordered_map<long long, vector< pair<int,int> > > skoky;
    for (int a=0; a<N; ++a)
        for (int b=0; b<N; ++b)
            if (a != b)
                skoky[ square_dist(a,b) ].push_back( {a,b} );

    vector<long long> dlzky;
    for (auto item : skoky) dlzky.push_back(item.first);
    sort( dlzky.begin(), dlzky.end() );
    reverse( dlzky.begin(), dlzky.end() );

    vector<int> najviac(N, -(1<<30));
    najviac[0] = 0;

    for (auto dlzka : dlzky) {
        vector< pair<int,int> > nove_info;
        for (auto skok : skoky[dlzka]) nove_info.push_back( { skok.second, najviac[ skok.first ]+1 } );
        for (auto rec : nove_info) najviac[rec.first] = max( najviac[rec.first], rec.second );
    }
    cout << najviac[N-1] << endl;
}
